from graphics import *
from math import *

cote = 800

fenetre = GraphWin(width = cote, height = cote) 
fenetre.setCoords(0, 0, cote, cote) # bottom left is (0, 0) and top right is (cote, cote)

def effacer_tout():
    un_rectangle = Rectangle(Point(0, 0), Point(cote,cote))
    un_rectangle.setFill('white')
    un_rectangle.draw(fenetre)

def echiquier(n):
    #effacer_tout()
    case=round(cote/n)
    for i in range(0,n):
        for j in range(0,n):
            un_rectangle = Rectangle(Point(i*case, j*case), Point((i+1)*case,(j+1)*case))
            if (i+j)%2==1:
                un_rectangle.setFill('black')
            else:
                un_rectangle.setFill('white')
            un_rectangle.draw(fenetre)
            

def afficher_reine(n,i,j):
    case=round(cote/n)
    rayon=round(cote/(2*n))-3
    disque = Circle(Point((i-1)*case+rayon,cote-((j-1)*case+rayon)),rayon)
    disque.setFill('red')
    disque.draw(fenetre)

def afficher_solution(n,liste):
    for i in range(0,len(liste)):
        afficher_reine(n,i+1,liste[i])

echiquier(4)
afficher_solution(4,[2,4,1,3])

fenetre.getMouse() # pause, attend un clic

sol5 = [[1], [1, 1], [1, 2], [1, 3], [1, 3, 1], [1, 3, 2], [1, 3, 3], [1, 3, 4], [1, 3, 5], [1, 3, 5, 1], [1, 3, 5, 2], [1, 3, 5, 2, 1], [1, 3, 5, 2, 2], [1, 3, 5, 2, 3], [1, 3, 5, 2, 4]]
echiquier(5)
for s in sol5:
    echiquier(5)
    afficher_solution(5,s)
    time.sleep(.5)

fenetre.getMouse() # pause, attend un clic

sol7 = [[1], [1, 1], [1, 2], [1, 3], [1, 3, 1], [1, 3, 2], [1, 3, 3], [1, 3, 4], [1, 3, 5], [1, 3, 5, 1], [1, 3, 5, 2], [1, 3, 5, 2, 1], [1, 3, 5, 2, 2], [1, 3, 5, 2, 3], [1, 3, 5, 2, 4], [1, 3, 5, 2, 4, 1], [1, 3, 5, 2, 4, 2], [1, 3, 5, 2, 4, 3], [1, 3, 5, 2, 4, 4], [1, 3, 5, 2, 4, 5], [1, 3, 5, 2, 4, 6], [1, 3, 5, 2, 4, 7], [1, 3, 5, 2, 5], [1, 3, 5, 2, 6], [1, 3, 5, 2, 7], [1, 3, 5, 3], [1, 3, 5, 4], [1, 3, 5, 5], [1, 3, 5, 6], [1, 3, 5, 7], [1, 3, 5, 7, 1], [1, 3, 5, 7, 2], [1, 3, 5, 7, 2, 1], [1, 3, 5, 7, 2, 2], [1, 3, 5, 7, 2, 3], [1, 3, 5, 7, 2, 4], [1, 3, 5, 7, 2, 4, 1], [1, 3, 5, 7, 2, 4, 2], [1, 3, 5, 7, 2, 4, 3], [1, 3, 5, 7, 2, 4, 4], [1, 3, 5, 7, 2, 4, 5], [1, 3, 5, 7, 2, 4, 6]]
echiquier(7)
for s in sol7:
    echiquier(7)
    afficher_solution(7,s)
    time.sleep(.5)

fenetre.getMouse() # pause, attend un clic